
#declare BozoDelta = 0.05;
#declare BozoScale = 1 / SceneWidth * 16;

#macro MakePattern( Highness )
	gradient x pigment_map{
							[ 0 color rgb Highness ]
							[ 0.2 color rgb Highness ]
							[ 0.3 bozo color_map{ 	[ 0 color rgb Highness - BozoDelta ]
													[ 0.5 color rgb Highness + BozoDelta ]
													[ 1 color rgb Highness - BozoDelta ] } 
								scale < BozoScale, BozoScale, 1 >	]
							[ 0.7 bozo color_map{ 	[ 0 color rgb Highness - BozoDelta ]
													[ 0.5 color rgb Highness + BozoDelta ]
													[ 1 color rgb Highness - BozoDelta ] }
								scale < BozoScale, BozoScale, 1 > ]
							[ 0.8 color rgb Highness ]
							[ 1 color rgb Highness ]
				}
#end

#declare HF_GroundFunc = pigment{ gradient y pigment_map{
                                                        [ 0 color rgb 0 ]
                                                        [ 1/32 MakePattern( 1/8 ) ]
                                                        [ 1/16 MakePattern( 1/4 ) ]
                                                        [ 2/16 MakePattern( 5.75/16 ) ]
                                                        //[ 1/32  color rgb 1/8 ]
                                                        //[ 1/16  color rgb 1/4 ]
                                                        //[ 2/16  color rgb 5.75/16 ]
                                                        [ 4/16 color rgb 0.475 ]
                                                        [ 10/16 color rgb 0.525 ]
                                                        //[ 11/16 MakePattern( 11/16 ) ]
                                                        //[ 12/16 MakePattern( 13/16 ) ]
                                                        //[ 13/16 MakePattern( 14.5/16 ) ]
                                                        [ 11/16 color rgb 11/16 ]
                                                        [ 12/16 color rgb 13/16 ]
                                                        [ 13/16 color rgb 14.5/16 ]
                                                        [ 14/16 color rgb 1  ]
                                                        [ 1 color rgb 1 ]
                                            }
                         }

#declare Ground =                                                        
height_field{
    function 1024, 1024{
        pigment{ HF_GroundFunc }        
    }
    smooth
    translate < -0.5, 0, -0.5 >
    rotate 180 * y
    scale < SceneWidth, SceneHeight / 2, SceneDepth > 
    translate < 0, 0, SceneDepth / 2 >
    texture{ T_grass_medium }
}

#declare WholeGround = 
union{
	object{ Ground translate SceneWidth * x }
	object{ Ground }
	object{ Ground translate -SceneWidth * x }
}

#declare GroundMin = min_extent( Ground );
#declare GroundMax = max_extent( Ground );
#declare GroundSize = GroundMax - GroundMin;
#debug concat("GroundMin: ", vstr(3, GroundMin, ",", 8, 4) , "\n" )
#debug concat("GroundMax: ", vstr(3, GroundMax, ",", 8, 4) , "\n" )
#debug concat("GroundSize: ", vstr(3, GroundSize, ",", 8, 4) , "\n" ) 
