
#declare RandPlace = seed( 1020 );
#declare RandTreeRotate = seed( 655 );

#if( PlaceTrees )
    #switch( TreeType )
		#case( 0 )
			#include "includes/firTree.inc" 
			#declare UsedTree = object{ FirTree scale 16 }
			#declare TreeSize = max_extent( UsedTree ) - min_extent( UsedTree );
			#debug concat("TreeSize is: ", vstr(3, TreeSize, ", ", 10, 4 ), "\n")
		#break
		#case( 1 )
			#include "includes/mapleB2.inc"
			#declare UsedTree = object{ MapleB2 scale 16 * 0.75}
			#declare TreeSize = max_extent( UsedTree ) - min_extent( UsedTree );
			#debug concat("TreeSize is: ", vstr(3, TreeSize, ", ", 10, 4 ), "\n")
		#break
	#end

	#ifdef( TreeSize )
		#declare PlaceXStart = -SceneWidth / 2 -TreeSize.x;
		#declare LineDecal = TreeSize.x / 2;
	#end

	#ifdef( TreeSize )
		#macro PlaceTreesMac()
			#local Decal = LineDecal;
			#local Norm = < 0, 0, 0 >;
			#for( ItZ, 0, 3 )
				#for( ItX, PlaceXStart, SceneWidth, TreeSize.x )
					#local TreePos = < ItX + Decal, 800, SceneDepth * 10.5 / 16 + ItZ * SceneDepth / 16 >
									+ < rand(RandPlace) * TreeSize.x / 4 - TreeSize.x / 8,
									 0, rand(RandPlace) * TreeSize.z / 4 - TreeSize.z / 8 >;
					#local FinalPos = trace( WholeGround, TreePos, -y, Norm );
					#if( Norm.x != 0 | Norm.y != 0 | Norm.z != 0 )
						#local FinalRotation = rand( RandTreeRotate ) * 360;
						#if( FinalPos.x <= SceneWidth / 2 - TreeSize.x )
							object{ UsedTree rotate FinalRotation * y translate FinalPos }
						#end
						#if( FinalPos.x - TreeSize.x / 2 <= -SceneWidth / 2 )
							object{ UsedTree rotate FinalRotation * y translate FinalPos + < SceneWidth, 0, 0 > }
						#end
					#end
				#end
				#if( Decal = LineDecal )
					#local Decal = 0;
				#elseif( Decal = 0 )
					#local Decal = LineDecal;
				#else
					#error "error: bad Decal value.\n"
				#end
			#end
		#end
	#end
#end