//Menhir

#declare MenhirTexture = 
texture{ pigment{color srgb 0.7} normal{ agate 0.2  } finish{ specular 0.01 roughness 0.01 } }

#declare PtsNumber = 5;

//The base of the stone pyramid
#declare Base =
prism{ conic_sweep linear_spline 1, 0.5, PtsNumber + 1, 
		#local Count = 0;
		#while( Count < PtsNumber + 1 )
			<vrotate(<0, 0, 1>, <0, 360 / PtsNumber * Count, 0>).x, 
			 vrotate(<0, 0, 1>, <0, 360 / PtsNumber * Count, 0>).z >
			#local Count = Count + 1;
		#end
}

//The top of the menhir
#declare Top =
prism{ conic_sweep linear_spline 1, 0, PtsNumber + 1, 
		#local Count = 0;
		#while( Count < PtsNumber + 1 )
			<vrotate(<0, 0, 1>, <0, 360 / PtsNumber * Count, 0>).x, 
			 vrotate(<0, 0, 1>, <0, 360 / PtsNumber * Count, 0>).z >
			 #local Count = Count + 1;
		#end
}

//The body/center of the menhir
#declare Body =
prism{ linear_sweep linear_spline 2, 1, PtsNumber + 1, 
		#local Count = 0;
		#while( Count < PtsNumber + 1 )
			<vrotate(<0, 0, 1>, <0, 360 / PtsNumber * Count, 0>).x, 
			 vrotate(<0, 0, 1>, <0, 360 / PtsNumber * Count, 0>).z >
			 #local Count = Count + 1;
		#end
}

//The whole menhir
#declare Menhir =
union{
	object{ Base translate -0.5*y scale <1, 2, 1> }
	object{ Body }
	object{ Top scale <1, 3, 1> rotate 180*x translate 5*y rotate 180*y}
	texture{ MenhirTexture }
}           

#declare MenhirDimensions = max_extent( Menhir ) - min_extent( Menhir );

#debug concat("Size of the menhir: ", vstr( 3, MenhirDimensions, ", ", 8, 8 ) , "\n")